﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows.Forms;
using Microsoft.VisualBasic;

namespace PseudonymizaceDat
{
    public partial class PrehledZadatelu : Form
    {
        public PrehledZadatelu()
        {
            InitializeComponent();
            lsvPrehledZadatelu.AutoResizeColumns(ColumnHeaderAutoResizeStyle.HeaderSize);
        }

        private void btnVsechnaData_Click(object sender, EventArgs e)
        {
            bool overenyUzivatel = false;

            OvereniUzivatele overeniUzivatele = new OvereniUzivatele();
            if (overeniUzivatele.ShowDialog() == DialogResult.OK)
            {
                overenyUzivatel = overeniUzivatele.OverenyUzivatel;
            }

            if (overenyUzivatel == true)
            {
                lsvPrehledZadatelu.Items.Clear();

                Methods method;
                method = new Methods();

                string zadatelID = null;
                string datumNarozeni = null;
                string jmeno = null;
                string prijmeni = null;
                string mistoNarozeni = null;
                string rodneCislo = null;
                string doplnujiciUdajeID = null;
                string vzdelani = null;
                string vek = null;
                string telCislo = null;
                string rodinnyStav = null;
                string absolvovanaZamestnani = null;
                string jineZdravotniPotize = null;
                string plneSobestacny = null;
                string pohybovePotize = null;
                string vyuzivatSluzebCharity = null;
                string zdravotniStavID = null;

                // Volání metod pro výpis údajů do listView
                string[,] returnValueZadatel = method.ZadatelSELECT(datumNarozeni, jmeno, mistoNarozeni, prijmeni, rodneCislo, zadatelID);
                string[,] returnValueDoplnujiciUdaje = method.DoplnujiciUdajeSELECT(zadatelID, doplnujiciUdajeID, vzdelani, vek, telCislo, rodinnyStav, absolvovanaZamestnani);
                string[,] returnValueZravotniStav = method.ZdravotniStavSELECT(jineZdravotniPotize, plneSobestacny, pohybovePotize, vyuzivatSluzebCharity, zadatelID, zdravotniStavID);

                int radky = returnValueZadatel.GetLength(0);
                int sloupce = returnValueZadatel.GetLength(1);
                int pomRadky = 0;
                int pomSloupce = 0;
                int pom = 0;

                while (pomRadky < radky)
                {
                    while (pom != 1)
                    {
                        ListViewItem lvi = new ListViewItem(returnValueZadatel[pomRadky, pomSloupce]);
                        pomSloupce++;
                        lvi.SubItems.Add(returnValueZadatel[pomRadky, pomSloupce]);
                        pomSloupce++;
                        lvi.SubItems.Add(returnValueZadatel[pomRadky, pomSloupce]);
                        pomSloupce++;
                        lvi.SubItems.Add(returnValueZadatel[pomRadky, pomSloupce]);
                        pomSloupce++;
                        lvi.SubItems.Add(returnValueZadatel[pomRadky, pomSloupce]);
                        pomSloupce++;
                        lvi.SubItems.Add(returnValueZadatel[pomRadky, pomSloupce]);

                        pomSloupce = 0;

                        lvi.SubItems.Add(returnValueDoplnujiciUdaje[pomRadky, pomSloupce]);
                        pomSloupce++;
                        lvi.SubItems.Add(returnValueDoplnujiciUdaje[pomRadky, pomSloupce]);
                        pomSloupce++;
                        lvi.SubItems.Add(returnValueDoplnujiciUdaje[pomRadky, pomSloupce]);
                        pomSloupce++;
                        lvi.SubItems.Add(returnValueDoplnujiciUdaje[pomRadky, pomSloupce]);
                        pomSloupce++;
                        lvi.SubItems.Add(returnValueDoplnujiciUdaje[pomRadky, pomSloupce]);

                        pomSloupce = 0;

                        lvi.SubItems.Add(returnValueZravotniStav[pomRadky, pomSloupce]);
                        pomSloupce++;
                        lvi.SubItems.Add(returnValueZravotniStav[pomRadky, pomSloupce]);
                        pomSloupce++;
                        lvi.SubItems.Add(returnValueZravotniStav[pomRadky, pomSloupce]);
                        pomSloupce++;
                        lvi.SubItems.Add(returnValueZravotniStav[pomRadky, pomSloupce]);


                        lsvPrehledZadatelu.Items.Add(lvi);

                        pomSloupce = 0;
                        pom = 1;
                    }

                    pom = 0;
                    pomRadky = pomRadky + 1;
                }

                lsvPrehledZadatelu.AutoResizeColumns(ColumnHeaderAutoResizeStyle.ColumnContent);
                lsvPrehledZadatelu.AutoResizeColumns(ColumnHeaderAutoResizeStyle.HeaderSize);
            }
            else
            {
                MessageBox.Show("Zadal jste špatný login nebo heslo. Zkuste to znovu!!");
            }
        }

        private void bntPseudonimizovanaData_Click(object sender, EventArgs e)
        {
            btnVsechnaData.PerformClick();
            lsvPrehledZadatelu.Columns[1].Width = 0;
            lsvPrehledZadatelu.Columns[2].Width = 0;
            lsvPrehledZadatelu.Columns[3].Width = 0;
            lsvPrehledZadatelu.Columns[4].Width = 0;
            lsvPrehledZadatelu.Columns[5].Width = 0;
            lsvPrehledZadatelu.Columns[8].Width = 0;
        }

        private void bntAnonymniData_Click(object sender, EventArgs e)
        {
            btnVsechnaData.PerformClick();
            lsvPrehledZadatelu.Columns[0].Width = 0;
            lsvPrehledZadatelu.Columns[1].Width = 0;
            lsvPrehledZadatelu.Columns[2].Width = 0;
            lsvPrehledZadatelu.Columns[3].Width = 0;
            lsvPrehledZadatelu.Columns[4].Width = 0;
            lsvPrehledZadatelu.Columns[5].Width = 0;
            lsvPrehledZadatelu.Columns[8].Width = 0;
        }

        private void bntSmazatData_Click(object sender, EventArgs e)
        {
            Methods method;
            method = new Methods();

            foreach (ListViewItem eachItem in lsvPrehledZadatelu.SelectedItems)
            {
                var item = lsvPrehledZadatelu.SelectedItems[0];
                string zadatelID = Regex.Match(item.ToString(), @"\d+").Value;
                lsvPrehledZadatelu.Items.Remove(eachItem);
                try
                {
                    method.DELETE_Radek(zadatelID);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
        }

        private void btnExportDat_Click(object sender, EventArgs e)
        {
            string route = "";

            try
            {
                FolderBrowserDialog fdb = new FolderBrowserDialog();
                fdb.RootFolder = Environment.SpecialFolder.Desktop;
                fdb.Description = "Vyberte složku";
                fdb.ShowNewFolderButton = false;

                if (fdb.ShowDialog() == DialogResult.OK)
                {
                    int x = (int)(System.Windows.SystemParameters.PrimaryScreenWidth / 2 - 200);
                    int y = (int)(System.Windows.SystemParameters.PrimaryScreenHeight / 2 - 100);
                    route = fdb.SelectedPath;

                    string input = Interaction.InputBox("Zadejte název souboru", "Název souboru", "export", x, y);
                    route = route + "\\" + input + ".csv";

                    Methods.ListViewToCSV(lsvPrehledZadatelu, route, false);
                }
            }
            catch (Exception ex)
            {

            }


        }

        private void btnUpravitData_Click(object sender, EventArgs e)
        {
            Methods method;
            method = new Methods();

            string zadatelID = null;
            string datumNarozeni = null;
            string jmeno = null;
            string prijmeni = null;
            string mistoNarozeni = null;
            string rodneCislo = null;
            string doplnujiciUdajeID = null;
            string vzdelani = null;
            string vek = null;
            string telCislo = null;
            string rodinnyStav = null;
            string absolvovanaZamestnani = null;
            string jineZdravotniPotize = null;
            string plneSobestacny = null;
            string pohybovePotize = null;
            string vyuzivatSluzebCharity = null;
            string zdravotniStavID = null;
            string kontakntiOsobaID = null;
            string kontaktniOsobaJmeno = null;
            string kontaktniOsobaPrijmeni = null;
            string kontaktniOsobaTelCislo = null;
            string poznamka = null;
            string prohlaseni = null;
            string poznamkaID = null;

            foreach (ListViewItem eachItem in lsvPrehledZadatelu.SelectedItems)
            {              
                var item = lsvPrehledZadatelu.SelectedItems[0];
                zadatelID = Regex.Match(item.ToString(), @"\d+").Value;

                string[,] returnValueZadatel = method.ZadatelSELECT(datumNarozeni, jmeno, mistoNarozeni, prijmeni, rodneCislo, zadatelID);
                DataUpravit.ZadatelID = returnValueZadatel[0, 0];
                DataUpravit.Jmeno = returnValueZadatel[0, 1];
                DataUpravit.Prijmeni = returnValueZadatel[0, 2];
                DataUpravit.RodneCislo = returnValueZadatel[0, 3];
                DataUpravit.MistoNarozeni = returnValueZadatel[0, 4];
                DataUpravit.DatumNarozeni = returnValueZadatel[0, 5];

                string[,] returnValueDoplnujiciUdaje = method.DoplnujiciUdajeSELECT(zadatelID, doplnujiciUdajeID, vzdelani, vek, telCislo, rodinnyStav, absolvovanaZamestnani);
                DataUpravit.Vzdelani = returnValueDoplnujiciUdaje[0, 0];
                DataUpravit.Vek = returnValueDoplnujiciUdaje[0, 3];
                DataUpravit.TelCislo = returnValueDoplnujiciUdaje[0, 2];
                DataUpravit.RodinnyStav = returnValueDoplnujiciUdaje[0, 1];
                DataUpravit.AbsolvovanaZamestnani = returnValueDoplnujiciUdaje[0, 4];

                string[,] returnValueZdravotniStav = method.ZdravotniStavSELECT(jineZdravotniPotize, plneSobestacny, pohybovePotize, vyuzivatSluzebCharity, zadatelID, zdravotniStavID);
                DataUpravit.PlneSobestacnyText = returnValueZdravotniStav[0, 0];
                DataUpravit.PohybovePotizeText = returnValueZdravotniStav[0, 1];
                DataUpravit.VyuzivatSluzebCharityText = returnValueZdravotniStav[0, 2];
                DataUpravit.JineZdravotniPotize = returnValueZdravotniStav[0, 3];

                string[,] returnZadatelKontaktniOsoba = method.ZadatelKontaktniOsobaSELECT(kontakntiOsobaID, zadatelID);
                DataUpravit.KontaktniOsobaID = returnZadatelKontaktniOsoba[0, 0];
                kontakntiOsobaID = returnZadatelKontaktniOsoba[0, 0];

                string[,] returnKontaktniOsoba = method.KontaktniOsobaSELECT(kontaktniOsobaJmeno, kontaktniOsobaPrijmeni, kontaktniOsobaTelCislo, kontakntiOsobaID);
                DataUpravit.KontaktniOsobaJmeno = returnKontaktniOsoba[0, 0];
                DataUpravit.KontaktniOsobaPrijmeni = returnKontaktniOsoba[0, 1];
                DataUpravit.KontaktniOsobaTelCislo = returnKontaktniOsoba[0, 2];

                string[,] returnPoznamka = method.PoznamkaSELECT(poznamka, prohlaseni, poznamkaID, zadatelID);
                DataUpravit.Poznamka = returnPoznamka[0, 0];
                DataUpravit.Prohlaseni = returnPoznamka[0, 1];

                Form datovyFormular = new DatovyFormular();
                datovyFormular.Show();

                DataUpravit.Jmeno = null;
                DataUpravit.Prijmeni = null;
                DataUpravit.RodneCislo = null;
                DataUpravit.MistoNarozeni = null;
                DataUpravit.DatumNarozeni = null;
                DataUpravit.DoplnujiciUdajeID = null;
                DataUpravit.Vzdelani = null;
                DataUpravit.Vek = null;
                DataUpravit.TelCislo = null;
                DataUpravit.RodinnyStav = null;
                DataUpravit.AbsolvovanaZamestnani = null;
                DataUpravit.PlneSobestacnyText = null;
                DataUpravit.PohybovePotizeText = null;
                DataUpravit.VyuzivatSluzebCharityText = null;
                DataUpravit.JineZdravotniPotize = null;
                DataUpravit.KontaktniOsobaJmeno = null;
                DataUpravit.KontaktniOsobaPrijmeni = null;
                DataUpravit.KontaktniOsobaTelCislo = null;
                DataUpravit.Poznamka = null;
                DataUpravit.Prohlaseni = null;
                DataUpravit.ZadatelID = null;
                DataUpravit.KontaktniOsobaID = null;
                kontakntiOsobaID = null;

                lsvPrehledZadatelu.Items.Clear();

            }
        }

        public static class DataUpravit
        {
            public static string ZadatelID { get; set; }
            public static string KontaktniOsobaID { get; set; }
            public static string Jmeno { get; set; }
            public static string Prijmeni { get; set; }
            public static string RodneCislo { get; set; }
            public static string MistoNarozeni { get; set; }
            public static string DatumNarozeni { get; set; }
            public static string DoplnujiciUdajeID { get; set; }
            public static string Vzdelani { get; set; }
            public static string Vek { get; set; }
            public static string TelCislo { get; set; }
            public static string RodinnyStav { get; set; }
            public static string AbsolvovanaZamestnani { get; set; }
            public static string PlneSobestacnyText { get; set; }
            public static string PohybovePotizeText { get; set; }
            public static string VyuzivatSluzebCharityText { get; set; }
            public static string JineZdravotniPotize { get; set; }
            public static string KontaktniOsobaJmeno { get; set; }
            public static string KontaktniOsobaPrijmeni { get; set; }
            public static string KontaktniOsobaTelCislo { get; set; }
            public static string Poznamka { get; set; }
            public static string Prohlaseni { get; set; }
        }

    }
}
